
-- create and populate aud_table
DROP TABLE IF EXISTS `aud_table`;

CREATE TABLE `aud_table` (
  `parent_table` varchar(30) DEFAULT NULL,
  `child_table` varchar(30) DEFAULT NULL,
  `level` int(11) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `aud_table` VALUES 
	('abstract_parameters_folder_aud','abstract_parameters_folder_aud',0),
	('abstract_parameters_folder_aud','parameters_folder_aud',1),
	('abstract_parameters_folder_aud','static_parameters_folder_aud',1),
	('action_instances_aud','action_instances_aud',0),
	('action_values_aud','action_values_aud',0),
	('action_values_aud','credentials_values_aud',1),
	('action_values_aud','input_values_aud',1),
	('action_values_aud','output_values_aud',1),
	('application_architectures_aud','application_architectures_aud',0),
	('application_components_aud','application_components_aud',0),
	('application_server_types_aud','application_server_types_aud',0),
	('applications_aud','applications_aud',0),
	('architecture_categories_aud','architecture_categories_aud',0),
	('architecture_server_types_aud','architecture_server_types_aud',0),
	('architectures_aud','architectures_aud',0),
	('art_definition_server_type_aud','art_definition_server_type_aud',0),
	('art_type_collection_params_aud','art_type_collection_params_aud',0),
	('art_version_in_pkg_aud','art_version_in_pkg_aud',0),
	('artifact_attribute_aud','artifact_attribute_aud',0),
	('artifact_attribute_value_aud','artifact_attribute_value_aud',0),
	('artifact_definition_aud','artifact_definition_aud',0),
	('artifact_package_aud','artifact_package_aud',0),
	('artifact_type_aud','artifact_type_aud',0),
	('artifact_type_components_aud','artifact_type_components_aud',0),
	('authorities_aud','authorities_aud',0),
	('basic_parameter_aud','basic_parameter_aud',0),
	('basic_parameter_aud','collection_parameters_aud',1),
	('basic_parameter_aud','file_parameters_aud',1),
	('basic_parameter_aud','model_parameters_aud',1),
	('basic_parameter_aud','options_parameters_aud',1),
	('categories_aud','categories_aud',0),
	('category_categories_aud','category_categories_aud',0),
	('category_category_aud','category_category_aud',0),
	('category_executables_aud','category_executables_aud',0),
	('child_param_folders_aud','child_param_folders_aud',0),
	('child_static_param_folders_aud','child_static_param_folders_aud',0),
	('component_categories_aud','component_categories_aud',0),
	('components_aud','components_aud',0),
	('composite_value_parts_aud','composite_value_parts_aud',0),
	('dashboard_instances_aud','dashboard_instances_aud',0),
	('dependencies_in_stage_aud','dependencies_in_stage_aud',0),
	('env_instances_aud','env_instances_aud',0),
	('env_procs_aud','env_procs_aud',0),
	('environments_aud','environments_aud',0),
	('exec_categories_aud','exec_categories_aud',0),
	('exec_server_acess_by_jxta_aud','exec_server_acess_by_jxta_aud',0),
	('exec_server_connect_nodes_aud','exec_server_connect_nodes_aud',0),
	('exec_servers_aud','exec_servers_aud',0),
	('executable_aud','executable_aud',0),
	('executable_aud','executable_instances_aud',1),
	('executable_aud','flows_aud',1),
	('executable_aud','model_steps_aud',1),
	('flow_order_links_aud','flow_order_links_aud',0),
	('group_roles_aud','group_roles_aud',0),
	('health_setting_aud','health_setting_aud',0),
	('mapping_constraint_aud','mapping_constraint_aud',0),
	('notif_email_recipients_aud','notif_email_recipients_aud',0),
	('notification_cond_states_aud','notification_cond_states_aud',0),
	('notification_conditions_aud','notif_conditions_aud',1),
	('notification_conditions_aud','notif_status_cond_aud',2),
	('notification_conditions_aud','notif_user_cond_aud',2),
	('notification_conditions_aud','notification_conditions_aud',0),
	('notification_recipients_aud','notification_recipients_aud',0),
	('notification_user_states_aud','notification_user_states_aud',0),
	('notifications_aud','notifications_aud',0),
	('opt_param_options_aud','opt_param_options_aud',0),
	('order_link_aud','order_link_aud',0),
	('order_link_aud','process_link_aud',1),
	('param_folder_params_aud','param_folder_params_aud',0),
	('permission_change_aud','permission_change_aud',0),
	('post_executable_aud','post_executable_aud',0),
	('post_process_action_aud','post_process_action_aud',0),
	('pre_executable_aud','pre_executable_aud',0),
	('precending_step_ids_aud','precending_step_ids_aud',0),
	('proc_category_categories_aud','proc_category_categories_aud',0),
	('proc_container_links_aud','proc_container_links_aud',0),
	('proc_container_map_constr_aud','proc_container_map_constr_aud',0),
	('proc_container_post_acts_aud','proc_container_post_acts_aud',0),
	('proc_container_q_constrain_aud','proc_container_q_constrain_aud',0),
	('proc_container_srv_flows_aud','proc_container_srv_flows_aud',0),
	('process_categories_aud','process_categories_aud',0),
	('process_category_processes_aud','process_category_processes_aud',0),
	('process_container_aud','edited_process_aud',1),
	('process_container_aud','process_container_aud',0),
	('process_container_aud','published_process_aud',1),
	('process_in_env_aud','process_in_env_aud',0),
	('purge_application_filter_aud','purge_application_filter_aud',0),
	('purge_content_filter_aud','purge_content_filter_aud',0),
	('purge_content_type_aud','purge_content_type_aud',0),
	('purge_environment_filter_aud','purge_environment_filter_aud',0),
	('purge_job_analytics_aud','purge_job_analytics_aud',0),
	('purge_job_aud','purge_job_aud',0),
	('purge_job_status_aud','purge_job_status_aud',0),
	('purge_run_status_aud','purge_run_status_aud',0),
	('purge_schedule_aud','purge_schedule_aud',0),
	('purge_schedule_exceptions_aud','purge_schedule_exceptions_aud',0),
	('rc_abstract_artifact_aud','rc_abstract_artifact_aud',0),
	('rc_abstract_artifact_aud','rc_artifacts_aud',1),
	('rc_approval_temp_def_aud','rc_approval_temp_def_aud',0),
	('rc_artifact_getters_aud','rc_artifact_clear_case_aud',1),
	('rc_artifact_getters_aud','rc_artifact_ftp_aud',1),
	('rc_artifact_getters_aud','rc_artifact_getters_aud',0),
	('rc_artifact_getters_aud','rc_artifact_git_aud',1),
	('rc_artifact_getters_aud','rc_artifact_http_aud',1),
	('rc_artifact_getters_aud','rc_artifact_local_file_aud',1),
	('rc_artifact_getters_aud','rc_artifact_remote_aud',1),
	('rc_artifact_getters_aud','rc_artifact_repository_aud',1),
	('rc_artifact_getters_aud','rc_artifact_ssh_aud',1),
	('rc_artifact_getters_aud','rc_artifact_svn_aud',1),
	('rc_artifact_getters_aud','rc_artifact_tfs_aud',1),
	('rc_artifact_instances_aud','rc_artifact_instances_aud',0),
	('rc_basic_modules_aud','rc_basic_modules_aud',0),
	('rc_basic_modules_aud','rc_env_module_templates_aud',2),
	('rc_basic_modules_aud','rc_module_templates_aud',1),
	('rc_basic_modules_aud','rc_modules_aud',2),
	('rc_basic_modules_aud','rc_rc_module_aud',2),
	('rc_basic_modules_aud','rc_template_parts_aud',1),
	('rc_deploy_tempate_stages_aud','rc_deploy_tempate_stages_aud',0),
	('rc_deploy_template_aud','rc_deploy_template_aud',0),
	('rc_deployment_file_aud','rc_deployment_file_aud',0),
	('rc_deployment_file_token_aud','rc_deployment_file_token_aud',0),
	('rc_manual_approval_aud','rc_manual_approval_aud',0),
	('rc_manual_approval_env_def_aud','rc_manual_approval_env_def_aud',0),
	('rc_module_dependencies_aud','rc_module_dependencies_aud',0),
	('rc_module_templ_param_vals_aud','rc_module_templ_param_vals_aud',0),
	('rc_module_templ_st_aud','rc_module_templ_st_aud',0),
	('rc_param_arr_val_members_aud','rc_param_arr_val_members_aud',0),
	('rc_param_loop_iter_values_aud','rc_param_loop_iter_values_aud',0),
	('rc_param_val_container_aud','rc_env_param_containers_aud',1),
	('rc_param_val_container_aud','rc_param_val_container_aud',0),
	('rc_param_values_aud','rc_param_values_aud',0),
	('rc_pre_steps_aud','rc_pre_steps_aud',0),
	('rc_prm_loop_itr_prm_vald_aud','rc_prm_loop_itr_prm_vald_aud',0),
	('rc_prm_val_loop_folder_itr_aud','rc_prm_val_loop_folder_itr_aud',0),
	('rc_prm_val_to_arr_mmbr_aud','rc_prm_val_to_arr_mmbr_aud',0),
	('rc_properties_aud','rc_properties_aud',0),
	('rc_rc_props_aud','rc_rc_props_aud',0),
	('rc_rc_stage_aud','rc_rc_stage_aud',0),
	('rc_release_cand_module_dep_aud','rc_release_cand_module_dep_aud',0),
	('rc_release_candidate_aud','rc_release_candidate_aud',0),
	('rc_release_props_aud','rc_release_props_aud',0),
	('rc_releases_aud','rc_releases_aud',0),
	('rc_rollback_plan_aud','rc_copy_rollback_plan_aud',1),
	('rc_rollback_plan_aud','rc_open_rollback_plan_aud',1),
	('rc_rollback_plan_aud','rc_relcand_rollback_plan_aud',1),
	('rc_rollback_plan_aud','rc_rollback_plan_aud',0),
	('rc_rollback_settings_aud','rc_env_rollback_settings_aud',1),
	('rc_rollback_settings_aud','rc_rollback_settings_aud',0),
	('rc_rollback_settings_aud','rc_temp_rollback_settings_aud',1),
	('rc_server_dependency_aud','rc_server_dependency_aud',0),
	('rc_server_type_param_vals_aud','rc_server_type_param_vals_aud',0),
	('rc_server_types_aud','rc_server_types_aud',0),
	('rc_servers_aud','rc_servers_aud',0),
	('rc_servicenow_a_env_def_aud','rc_servicenow_a_env_def_aud',0),
	('rc_servicenow_approval_aud','rc_servicenow_approval_aud',0),
	('rc_stages_aud','rc_stages_aud',0),
	('rc_stages_modules_aud','rc_stages_modules_aud',0),
	('rc_step_a_env_def_aud','rc_step_a_env_def_aud',0),
	('rc_step_approval_aud','rc_step_approval_aud',0),
	('rc_steps_in_dpstage_aud','rc_steps_in_dpstage_aud',0),
	('rc_template_modules_aud','rc_template_modules_aud',0),
	('rc_template_part_parts_aud','rc_template_part_parts_aud',0),
	('rc_template_props_aud','rc_template_props_aud',0),
	('rc_template_stages_aud','rc_template_stages_aud',0),
	('rc_templates_aud','rc_templates_aud',0),
	('rc_tmp_module_dependencies_aud','rc_tmp_module_dependencies_aud',0),
	('rc_token_definition_aud','rc_token_definition_aud',0),
	('rc_token_mask_aud','rc_token_mask_aud',0),
	('rc_token_value_aud','rc_token_value_aud',0),
	('rc_version_aud','rc_version_aud',0),
	('remote_executions_map_aud','remote_executions_map_aud',0),
	('revision_mapping_aud','revision_mapping_aud',0),
	('roles_aud','roles_aud',0),
	('sched_servers_pair_aud','sched_servers_pair_aud',0),
	('sched_to_instance_aud','sched_to_instance_aud',0),
	('schedule_definitions_aud','schedule_def_abs_cron_aud',1),
	('schedule_definitions_aud','schedule_def_cron_aud',2),
	('schedule_definitions_aud','schedule_def_daily_aud',2),
	('schedule_definitions_aud','schedule_def_month_aud',2),
	('schedule_definitions_aud','schedule_def_once_aud',2),
	('schedule_definitions_aud','schedule_def_simple_aud',1),
	('schedule_definitions_aud','schedule_def_week_aud',2),
	('schedule_definitions_aud','schedule_definitions_aud',0),
	('scheduled_data_aud','scheduled_data_aud',0),
	('server_category_aud','server_category_aud',0),
	('server_flow_aud','server_flow_aud',0),
	('server_ips_aud','server_ips_aud',0),
	('server_qnty_constraints_aud','server_qnty_constraints_aud',0),
	('server_type_components_aud','server_type_components_aud',0),
	('server_type_instance_aud','server_type_instance_aud',0),
	('server_types_aud','server_types_aud',0),
	('servers_aud','servers_aud',0),
	('str_list_params_aud','str_list_params_aud',0),
	('str_list_vals_aud','str_list_vals_aud',0),
	('str_params_aud','str_params_aud',0),
	('user_groups_aud','user_groups_aud',0),
	('user_pipeline_env_order_aud','user_pipeline_env_order_aud',0),
	('user_pipeline_report_pref_aud','user_pipeline_report_pref_aud',0),
	('users_aud','users_aud',0),
	('users_in_group_aud','users_in_group_aud',0),
	('value_aud','composite_value_aud',1),
	('value_aud','concrete_value_aud',1),
	('value_aud','null_values_aud',1),
	('value_aud','p_value_aud',2),
	('value_aud','parameter_value_aud',1),
	('value_aud','value_aud',0),
	('values_for_params_aud','values_for_params_aud',0),
	('widget_types_aud','widget_types_aud',0);




DELIMITER //


DROP PROCEDURE IF EXISTS sp_purge_audit
//
CREATE PROCEDURE sp_purge_audit(
	IN p_time_limit int,
	IN p_time_delay int,
	IN p_delete_chunk_size int
	)
BEGIN
	
	DECLARE l_parent_table, l_child_table, l_prev_parent_table VARCHAR(30);
	DECLARE l_stop_time datetime;
	DECLARE l_rows_deleted, l_rows_inserted int;
	-- DECLARE l_sql VARCHAR(1000);
	DECLARE finished INTEGER DEFAULT 0;
	DECLARE cur_aud_table CURSOR FOR
		SELECT parent_table, child_table FROM aud_table order by parent_table, level desc, child_table;

	DECLARE CONTINUE HANDLER FOR NOT FOUND SET finished = 1;	

	-- set default values
	IF p_delete_chunk_size is null THEN SET p_delete_chunk_size = 10000; END IF;

	-- set l_stop_time
	CASE 
		WHEN p_time_limit is null THEN set l_stop_time = null; 
		ELSE SET l_stop_time = DATE_ADD(now(), INTERVAL p_time_limit SECOND); 
	END CASE;

	select concat('Purging Audit tables. Will stop purging at: ', ifnull(l_stop_time, 'null')) as Status;

  	set l_prev_parent_table = ' ';

	OPEN cur_aud_table;

	-- Loop through the aud_table cursor
	-- Stop iterating if stop_time is reached
	WHILE finished <> 1 AND (l_stop_time is null OR now() < l_stop_time)
	DO
		FETCH cur_aud_table INTO l_parent_table, l_child_table;
		-- select l_parent_table, l_child_table;
		

			-- execute the delete in chunks but stop if stop_time is reached
			set l_rows_deleted = p_delete_chunk_size;
			WHILE l_rows_deleted <> 0 AND (l_stop_time is null OR now() < l_stop_time)
			DO
				SET @delete_sql = concat('DELETE FROM ', l_child_table,  ' WHERE rev IN (');
				SET @delete_sql = concat(@delete_sql, 'SELECT r.rev FROM (');
				SET @delete_sql = concat(@delete_sql, 'SELECT aud.rev from ', l_parent_table, ' aud INNER JOIN designrevisionentity d ON aud.rev = d.id ');
				SET @delete_sql = concat(@delete_sql, 'WHERE d.processStatus is not null ) r ) LIMIT ?');
				-- select @delete_sql;	
				set @p = p_delete_chunk_size;
				PREPARE stmt FROM @delete_sql;
			    EXECUTE stmt USING @p;
			    SELECT ROW_COUNT() INTO l_rows_deleted;
			    select concat(l_rows_deleted, ' rows were deleted from table: ', l_child_table) as rows_deleted;
		    	IF p_time_limit IS NOT NULL THEN
		    		DO SLEEP(p_time_delay);
		    	END IF;
			END WHILE;
			DEALLOCATE PREPARE stmt;

		


	END WHILE;

	CLOSE cur_aud_table;

	-- Delete from audit record tables
	IF (l_stop_time is null OR now() < l_stop_time) THEN

		-- create temp table to store audit record ID's to be deleted
		CREATE TEMPORARY TABLE IF NOT EXISTS revision_auditingentry_tmp (
			designrevisionentity_id int, 
	 		auditEntries_id bigint,
	 		primary key(auditEntries_id)
	 	);

		SET l_rows_inserted = 1;  -- So the following will run at least one iteration
	 	WHILE l_rows_inserted <> 0 AND (l_stop_time is null OR now() < l_stop_time)
	 	DO
	 		TRUNCATE TABLE revision_auditingentry_tmp;
	 		SET @insert_sql = concat('insert into revision_auditingentry_tmp (designrevisionentity_id, auditEntries_id) SELECT r.designrevisionentity_id, r.auditEntries_id '); 
	 		SET @insert_sql = concat(@insert_sql, 'FROM revision_auditingentry r INNER JOIN designrevisionentity d ON r.designrevisionentity_id = d.id  WHERE d.processStatus is not null LIMIT ?');
	 		set @p = p_delete_chunk_size;
	 		PREPARE stmt from @insert_sql;
	 		EXECUTE stmt USING @p;
	 		SELECT ROW_COUNT() into l_rows_inserted;
	 		DEALLOCATE PREPARE stmt;

	 		DELETE r 
	 		FROM revision_auditingentry_tmp r_tmp, revision_auditingentry r
	 		WHERE r_tmp.designrevisionentity_id = r.designrevisionentity_id
	 		AND r_tmp.auditEntries_id = r.auditEntries_id;
	 		SELECT ROW_COUNT() INTO l_rows_deleted;
	 		select concat(l_rows_deleted, ' rows were deleted from table: revision_auditingentry') as rows_deleted;


	 		DELETE FROM auditingentry 
	 		WHERE id IN (SELECT auditEntries_id FROM revision_auditingentry_tmp);
	 		SELECT ROW_COUNT() INTO l_rows_deleted;
	 		select concat(l_rows_deleted, ' rows were deleted from table: auditingentry') as rows_deleted;

	 	END WHILE;



	END IF;

	IF (now() > l_stop_time) THEN
    	select 'Exceeded Time limit.  Exiting procedure.' as Status;
  	ELSE
    	select 'Purge of Audit tablse completed.' as Status;
    END IF;
    	
	DROP TABLE IF EXISTS revision_auditingentry_tmp;
END//

DELIMITER ;	

























